/*
 * Copyright (C) 2011 David C. McCallum
 * For conditions of distribution and use, see the copyright notice in Dasyne.hpp
*/

/* DESCRIPTION
  Handles events for the DTimer class, calls DTimer::update()
  whenever DEngine::update() is called.
*/

#ifndef DTIMEREVENT_HPP_INCLUDED
#define DTIMEREVENT_HPP_INCLUDED

#include "DEvent.hpp"

namespace libdasyne
{
    class DTimer;

    class DTimerEvent : public DEvent
    {
        public:
            //constructor
            DTimerEvent(DEngine *newEngine,
                        DTimer *newTimer);

            //destructor
            virtual ~DTimerEvent(void);

            //Event handler, called when the DEngine updates. Returns the number of events
            //dispatched, this should normally be zero or one.
            unsigned int update(void);

        private:
            //Pointer to the timer to notify when the engine updates
            DTimer *timer;
            
    };//DTimerEvent
}//namespace libdasyne

#endif
